
/* : sysdefs.SH,v 1.6 1996/03/14 17:27:34 wfp5p Exp $ */
/*******************************************************************************
 *  The Elm Mail System  -  : 1.6 $   : Exp $
 *
 * 			Copyright (c) 1988-1992 USENET Community Trust
 * 			Copyright (c) 1986,1987 Dave Taylor
 *******************************************************************************
 * Bug reports, patches, comments, suggestions should be sent to:
 *
 *	Bill Pemberton, Elm Coordinator
 *	elm@DSI.COM	
 *
 *******************************************************************************
 * $Log: sysdefs.SH,v $
# Revision 1.6  1996/03/14  17:27:34  wfp5p
# Alpha 9
#
# Revision 1.5  1995/09/29  17:41:00  wfp5p
# Alpha 8 (Chip's big changes)
#
# Revision 1.4  1995/06/30  14:56:22  wfp5p
# Alpha 5
#
# Revision 1.3  1995/06/01  13:07:37  wfp5p
# Changes over to enhanced mode in for the print command.  From Chip Rosenthal
# <chip@unicom.com>
#
# Revision 1.2  1995/05/10  13:34:32  wfp5p
# Added mailing list stuff by Paul Close <pdc@sgi.com>
# And NetBSD stuff.
#
 * Revision 1.1.1.1  1995/04/19  20:38:31  wfp5p
 * Initial import of elm 2.4 PL0 as base for elm 2.5.
 *
 ******************************************************************************/

/**  System level, configurable, defines for the ELM mail system.  **/

/* max headers to weed out */
#define MAX_IN_WEEDLIST 150

/* max hops in return addr to E)veryone  */
#define MAX_HOPS 35

#define DEFAULT_BATCH_SUBJECT "no subject (file transmission)"

/* if mydomain file is missing */
#define DEFAULT_DOMAIN ".triaxx.org"

/* FOO - interim while the intent for MIME support is sorted out */
#define MIME_SEND
#ifdef MIME
# define MIME_RECV
#endif

/* system data files - fully rooted pathnames */

#define system_data_file	"/usr/pkg/lib/elm/aliases"
#define system_text_file	"/usr/pkg/lib/elm/aliases.text"
#define system_hostdom_file	"/usr/pkg/lib/elm/domain"
#define system_rc_file		"/usr/pkg/lib/elm/elm.rc"
#define system_rcinfo_file	"/usr/pkg/lib/elm/elmrc-info"
#define system_mimetypes_file	"/usr/pkg/lib/elm/mime-types"
#define system_mlist_file	"/usr/pkg/lib/elm/mlists"
#define system_help_dir		"/usr/pkg/lib/elm"


/* user data files - relative to user home directory */

#define elmrcfile	".elm/elmrc"
#define old_elmrcfile	".elm/elmrc.old"
#define mailheaders	".elm/elmheaders"
#define mlistfile	".elm/mlists"

#define ALIAS_TEXT	".elm/aliases.text"
#define ALIAS_DATA	".elm/aliases"

#define dead_letter	"Canceled.mail"
#define unedited_mail	"emergency.mbox"

/* where to put the output of the elm -d command... */
#define DEBUGFILE	"ELM:debug.info"
#define OLDEBUG		"ELM:debug.last"


/* temporary files */

#define	default_temp   	"/tmp/"
#define temp_file	"snd."
#define temp_form_file	"form."
#define temp_mbox	"mbox."
#define temp_print      "print."
#define temp_edit	"elm-edit"
#define temp_uuname	"uuname."
#define temp_state	"est."


/* commands and options */

#define emacs_editor	"emacs"
#define vi_editor	"/usr/bin/vi"

#define default_editor	"/usr/bin/vi "

#define default_shell	"/bin/ksh"
#define default_pager	"builtin+"
#define default_printout "/usr/bin/lp"

#define sendmail	"/usr/sbin/sendmail"
#define smflags		"-oi -oem"	/* ignore dots and mail back errors */
#define smflagsv	"-oi -oem -v"	/* ...plus verbose voyuer mode */
#define smflagmt	" -om"		/* metoo copy to sender */

#define execmail	""
#define emflags		""
#define emflagsv	"-d"		/* verbose voyuer mode */
#define emflagmt	"-m"		/* metoo copy to sender */

#define submitmail	""
#define submitflags	"-mlrnvxto,cc*"
#define submitflags_s	"-mlrnv"

#define mailer		"/usr/sbin/sendmail"

#define newalias	"newalias 1>&2 > /dev/null"
#define readmsg		"readmsg"

#define remove_cmd	"/bin/rm -f"	/* how to remove a file */
#define cat		"/bin/cat"		/* how to display files */
#define sed_cmd		"/usr/bin/sed"		/* how to access sed */
#define move_cmd	"/bin/mv"		/* how to access sed */
#define uuname		"uuname"	/* how to get a uuname  */


/* other system definitions */

#define mailhome	"/var/mail/"

#define default_charset		"iso-8859-1"
#define default_display_charset	"iso-8859-1"

#define MSG_SEPARATOR	"\001\001\001\001\n"	/* mmdf message seperator */

		

